/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dashboard2014;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;

/**
 * @author Robotics
 */
public class FakeFrameGrabber implements FrameGrabber {

    private final BufferedImage img;

    public static BufferedImage getRandomStoredImage() {
        String[] p = new String[]{
            "no 320 0",
            "no 320 30",
            "no 480 0",
            "no 480 30",
            "no 640 0",
            "no 640 30",
            "yes 320 0",
            "yes 320 30",
            "yes 480 0",
            "yes 480 30",
            "yes 640 0",
            "yes 640 30",
            "yes 640 70"
        };

        Random r = new Random();
        int v = r.nextInt(p.length);
        String path = p[v];

        InputStream i = FakeFrameGrabber.class.getResourceAsStream(String.format("resources/images/%s.jpg", path));
        BufferedImage x = null;
        try {
            x = ImageIO.read(i);
        } catch (IOException ex) {
            Logger.getLogger(FakeFrameGrabber.class.getName()).log(Level.SEVERE, null, ex);
        }
        return x;
    }

    public static final String imagePath = "targets";

    public static BufferedImage getRandomFreeImage() {
        File f = new File(imagePath);
        Random r = new Random();

        for (int i = 0; i < 2; i++) {
            String[] level = f.list();
            String next = level[r.nextInt(level.length)];
            if (!next.startsWith("_")) {
                f = new File(f.getPath() + File.separator + next);
            } else {
                i -= 1;
            }
        }

        try {
            return ImageIO.read(f);
        } catch (IOException ex) {
            System.err.println(ex.getMessage());
            return null;
        }

    }

    public FakeFrameGrabber(FrameNotifier x) {
        BufferedImage i = getRandomFreeImage();

        Vision.VisionResult r = Vision.process(i);
        img = r.filtered;
        Vision.writeData(r, Backend.getDataPath("vision"));

        x.notifyNewFrame();
    }

    @Override
    public void setIP(int team) {
    }

    public static final String relativePath = "test.jpg";

    @Override
    public BufferedImage getLatestImage() {
        return img;
    }
}
