/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dashboard2014;

import java.awt.Color;
import java.awt.Component;
import java.util.Set;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

/**
 *
 * @author Robotics
 */
public class MainPanel extends javax.swing.JFrame {

    private static final long serialVersionUID = 1L;

    public final Backend backend;

    /**
     * Creates new form NewJFrame
     *
     * @param args
     */
    public MainPanel(Set<String> args) {
        initComponents();

        KickerPowerBar.setOrientation(SwingConstants.VERTICAL);
        KickerPowerBar.setBackground(Color.WHITE);
        KickerPowerBar.setForeground(Color.BLUE);

        SliderComplex s = new SliderComplex(TargetPower, KickerPowerBar);
        s.set(0.11);
        SliderComplex a = new SliderComplex(ActualAngle, AngleBar);
        a.set(0.15);

        setColor(Color.BLACK, DriverView);

        TeamNumChooser t = new TeamNumChooser(TeamNumberBox, TeamNumberChooser, 0);

        backend = new Backend(s, a, (VideoOutput) VideoDisplay, t,
                PreferencesBox, this, args);
    }

    public void flashBackground(boolean high) {
        setColor(high ? Color.YELLOW : Color.WHITE, DriverView);
    }

    public void setConnected(boolean linked) {
        setColor(linked ? Color.WHITE : Color.BLACK, DriverView);
    }

    private void setColor(Color c, JPanel p) {
        p.setBackground(c);
        synchronized (p.getTreeLock()) {
            for (Component l : p.getComponents()) {
                if (l instanceof JPanel) {
                    setColor(c, (JPanel) l);
                }
            }
        }
    }

    public void setTitleTeam(int team) {
        this.setTitle(String.format("Dashboard 2014: Team %d", team));
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings({"unchecked", "Convert2Diamond"})
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        Tabs = new javax.swing.JTabbedPane();
        DriverView = new javax.swing.JPanel();
        VideoDisplay = new VideoOutput();
        filler4 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(32767, 0));
        filler10 = new javax.swing.Box.Filler(new java.awt.Dimension(10, 0), new java.awt.Dimension(10, 0), new java.awt.Dimension(10, 32767));
        AnglePanel = new javax.swing.JPanel();
        filler6 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 20), new java.awt.Dimension(0, 20), new java.awt.Dimension(32767, 20));
        AngleBar = new ColoredSlider();
        filler7 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 15), new java.awt.Dimension(0, 15), new java.awt.Dimension(32767, 15));
        ActualAngle = new javax.swing.JLabel();
        filler8 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 20), new java.awt.Dimension(0, 20), new java.awt.Dimension(32767, 20));
        filler11 = new javax.swing.Box.Filler(new java.awt.Dimension(10, 0), new java.awt.Dimension(10, 0), new java.awt.Dimension(10, 32767));
        filler5 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(32767, 0));
        PowerBarPanel = new javax.swing.JPanel();
        filler2 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 20), new java.awt.Dimension(0, 20), new java.awt.Dimension(32767, 20));
        KickerPowerBar = new javax.swing.JProgressBar();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 15), new java.awt.Dimension(0, 15), new java.awt.Dimension(32767, 15));
        TargetPower = new javax.swing.JLabel();
        filler3 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 20), new java.awt.Dimension(0, 20), new java.awt.Dimension(32767, 20));
        filler9 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(32767, 0));
        filler12 = new javax.swing.Box.Filler(new java.awt.Dimension(10, 0), new java.awt.Dimension(10, 0), new java.awt.Dimension(10, 32767));
        SettingView = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        PrefBoxLabel = new javax.swing.JLabel();
        PrefBoxScrollPane = new javax.swing.JScrollPane();
        PreferencesBox = new javax.swing.JTable();
        jPanel3 = new javax.swing.JPanel();
        TeamNumberBox = new javax.swing.JFormattedTextField();
        TeamNumberLabel = new javax.swing.JLabel();
        TeamNumberChooser = new javax.swing.JComboBox<SItem>();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Dashboard 2014");
        setMaximumSize(null);
        setMinimumSize(null);
        setPreferredSize(null);
        setResizable(false);

        Tabs.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        Tabs.setTabPlacement(javax.swing.JTabbedPane.RIGHT);
        Tabs.setToolTipText("");
        Tabs.setMaximumSize(null);
        Tabs.setMinimumSize(null);
        Tabs.setPreferredSize(null);

        DriverView.setBackground(new java.awt.Color(255, 255, 255));
        DriverView.setMaximumSize(new java.awt.Dimension(1300, 520));
        DriverView.setMinimumSize(new java.awt.Dimension(1000, 510));
        DriverView.setName(""); // NOI18N
        DriverView.setPreferredSize(null);
        DriverView.setRequestFocusEnabled(false);
        DriverView.setLayout(new javax.swing.BoxLayout(DriverView, javax.swing.BoxLayout.LINE_AXIS));

        VideoDisplay.setBackground(new java.awt.Color(102, 102, 102));
        VideoDisplay.setMaximumSize(new java.awt.Dimension(680, 510));
        VideoDisplay.setMinimumSize(new java.awt.Dimension(680, 510));
        VideoDisplay.setName("Video Display"); // NOI18N
        VideoDisplay.setPreferredSize(new java.awt.Dimension(680, 510));
        VideoDisplay.setRequestFocusEnabled(false);

        javax.swing.GroupLayout VideoDisplayLayout = new javax.swing.GroupLayout(VideoDisplay);
        VideoDisplay.setLayout(VideoDisplayLayout);
        VideoDisplayLayout.setHorizontalGroup(
            VideoDisplayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 680, Short.MAX_VALUE)
        );
        VideoDisplayLayout.setVerticalGroup(
            VideoDisplayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, Short.MAX_VALUE, Short.MAX_VALUE)
        );

        DriverView.add(VideoDisplay);
        VideoDisplay.getAccessibleContext().setAccessibleDescription("");

        DriverView.add(filler4);
        DriverView.add(filler10);

        AnglePanel.setBackground(DriverView.getBackground());
        AnglePanel.setMaximumSize(new java.awt.Dimension(250, 32897));
        AnglePanel.setName(""); // NOI18N
        AnglePanel.setPreferredSize(new java.awt.Dimension(175, 500));
        AnglePanel.setLayout(new javax.swing.BoxLayout(AnglePanel, javax.swing.BoxLayout.Y_AXIS));
        AnglePanel.add(filler6);

        AngleBar.setOrientation(1);
        AngleBar.setToolTipText("");
        AngleBar.setValue(40);
        AngleBar.setMaximumSize(new java.awt.Dimension(3000, 32767));
        AnglePanel.add(AngleBar);
        AnglePanel.add(filler7);

        ActualAngle.setFont(new java.awt.Font("Times New Roman", 1, 80)); // NOI18N
        ActualAngle.setForeground(new java.awt.Color(25, 25, 25));
        ActualAngle.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        ActualAngle.setText("80");
        ActualAngle.setToolTipText("");
        ActualAngle.setMaximumSize(new java.awt.Dimension(300, 75));
        ActualAngle.setPreferredSize(new java.awt.Dimension(300, 75));
        ActualAngle.setRequestFocusEnabled(false);
        AnglePanel.add(ActualAngle);
        AnglePanel.add(filler8);

        DriverView.add(AnglePanel);
        DriverView.add(filler11);
        DriverView.add(filler5);

        PowerBarPanel.setBackground(DriverView.getBackground());
        PowerBarPanel.setMaximumSize(new java.awt.Dimension(250, 32897));
        PowerBarPanel.setName(""); // NOI18N
        PowerBarPanel.setPreferredSize(new java.awt.Dimension(175, 500));
        PowerBarPanel.setLayout(new javax.swing.BoxLayout(PowerBarPanel, javax.swing.BoxLayout.Y_AXIS));
        PowerBarPanel.add(filler2);

        KickerPowerBar.setOrientation(1);
        KickerPowerBar.setToolTipText("");
        KickerPowerBar.setValue(40);
        KickerPowerBar.setMaximumSize(new java.awt.Dimension(3000, 32767));
        PowerBarPanel.add(KickerPowerBar);
        PowerBarPanel.add(filler1);

        TargetPower.setFont(new java.awt.Font("Times New Roman", 1, 80)); // NOI18N
        TargetPower.setForeground(new java.awt.Color(25, 25, 25));
        TargetPower.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        TargetPower.setText("80");
        TargetPower.setToolTipText("");
        TargetPower.setMaximumSize(new java.awt.Dimension(300, 75));
        TargetPower.setPreferredSize(new java.awt.Dimension(300, 75));
        TargetPower.setRequestFocusEnabled(false);
        PowerBarPanel.add(TargetPower);
        PowerBarPanel.add(filler3);

        DriverView.add(PowerBarPanel);
        DriverView.add(filler9);
        DriverView.add(filler12);

        Tabs.addTab("D", null, DriverView, "Driver Panel");

        SettingView.setBackground(new java.awt.Color(204, 204, 204));
        SettingView.setPreferredSize(null);
        SettingView.setVerifyInputWhenFocusTarget(false);

        jPanel2.setBackground(SettingView.getBackground());
        jPanel2.setToolTipText("");
        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

        PrefBoxLabel.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        PrefBoxLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        PrefBoxLabel.setText("Preferences");
        jPanel2.add(PrefBoxLabel);

        PrefBoxScrollPane.setMaximumSize(null);
        PrefBoxScrollPane.setMinimumSize(null);
        PrefBoxScrollPane.setPreferredSize(new java.awt.Dimension(400, 400));

        PreferencesBox.setModel(Backend.getPreferencesModel());
        PrefBoxScrollPane.setViewportView(PreferencesBox);

        jPanel2.add(PrefBoxScrollPane);

        TeamNumberBox.setColumns(4);
        TeamNumberBox.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("#0"))));
        TeamNumberBox.setText("122");
        TeamNumberBox.setToolTipText("");

        TeamNumberLabel.setText("Team Number");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(TeamNumberLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 104, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(TeamNumberChooser, javax.swing.GroupLayout.Alignment.LEADING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(TeamNumberBox, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 80, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(TeamNumberLabel)
                .addGap(11, 11, 11)
                .addComponent(TeamNumberBox, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(TeamNumberChooser, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        javax.swing.GroupLayout SettingViewLayout = new javax.swing.GroupLayout(SettingView);
        SettingView.setLayout(SettingViewLayout);
        SettingViewLayout.setHorizontalGroup(
            SettingViewLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(SettingViewLayout.createSequentialGroup()
                .addGap(23, 23, 23)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 463, Short.MAX_VALUE)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        SettingViewLayout.setVerticalGroup(
            SettingViewLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(SettingViewLayout.createSequentialGroup()
                .addGap(17, 17, 17)
                .addGroup(SettingViewLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(66, Short.MAX_VALUE))
        );

        Tabs.addTab("S", null, SettingView, "Settings Panel");
        SettingView.getAccessibleContext().setAccessibleName("");

        getContentPane().add(Tabs, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel ActualAngle;
    private javax.swing.JProgressBar AngleBar;
    private javax.swing.JPanel AnglePanel;
    private javax.swing.JPanel DriverView;
    private javax.swing.JProgressBar KickerPowerBar;
    private javax.swing.JPanel PowerBarPanel;
    private javax.swing.JLabel PrefBoxLabel;
    private javax.swing.JScrollPane PrefBoxScrollPane;
    private javax.swing.JTable PreferencesBox;
    private javax.swing.JPanel SettingView;
    private javax.swing.JTabbedPane Tabs;
    private javax.swing.JLabel TargetPower;
    private javax.swing.JFormattedTextField TeamNumberBox;
    private javax.swing.JComboBox<SItem> TeamNumberChooser;
    private javax.swing.JLabel TeamNumberLabel;
    private javax.swing.JPanel VideoDisplay;
    private javax.swing.Box.Filler filler1;
    private javax.swing.Box.Filler filler10;
    private javax.swing.Box.Filler filler11;
    private javax.swing.Box.Filler filler12;
    private javax.swing.Box.Filler filler2;
    private javax.swing.Box.Filler filler3;
    private javax.swing.Box.Filler filler4;
    private javax.swing.Box.Filler filler5;
    private javax.swing.Box.Filler filler6;
    private javax.swing.Box.Filler filler7;
    private javax.swing.Box.Filler filler8;
    private javax.swing.Box.Filler filler9;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    // End of variables declaration//GEN-END:variables
}
