/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dashboard2014;

import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import javax.imageio.ImageIO;

/**
 *
 * @author Robotics
 */
class StreamFrameGrabber extends Thread implements FrameGrabber {

    private static final int PAUSE_TIME = 2000;
    private static final int READ_TIMEOUT = 300;
    private static final int MIN_FRAME_TIME = 10;
    private boolean ipChange;
    private int team;
    private final FrameNotifier out;

    // thanks
    @SuppressWarnings(value = "CallToThreadStartDuringObjectConstruction")
    public StreamFrameGrabber(FrameNotifier o) {
        super("Stream Frame Grabber");
        setDaemon(true);
        team = 0;
        ipChange = false;
        img = null;
        this.start();
        out = o;
    }
    private volatile BufferedImage img;

    @Override
    public BufferedImage getLatestImage() {
        return img;
    }

    @Override
    public void run() {
        // modeled on implementation in SFX
        final int[] START_BYTES = {0xFF, 0xD8};
        final int[] END_BYTES = {0xFF, 0xD9};
        final ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        while (true) {
            String addr = String.format("http://%s/axis-cgi/mjpg/video.cgi", Backend.getCameraIP(team));
            try {
                URLConnection target = new URL(addr).openConnection();
                target.setReadTimeout(READ_TIMEOUT);
                InputStream is = target.getInputStream();
                long prev_timestamp = 0;
                while (!ipChange) {
                    // is the below hack (is.skip()) necessary??
                    do {
                        is.skip(is.available());
                    } while (System.currentTimeMillis() < (prev_timestamp + MIN_FRAME_TIME));
                    buffer.reset();
                    for (int i = 0; i < START_BYTES.length;) {
                        int b = is.read();
                        if (b == START_BYTES[i]) {
                            i++;
                        } else {
                            i = 0;
                        }
                    }
                    for (int i = 0; i < START_BYTES.length; ++i) {
                        buffer.write(START_BYTES[i]);
                    }
                    for (int i = 0; i < END_BYTES.length;) {
                        int b = is.read();
                        buffer.write(b);
                        if (b == END_BYTES[i]) {
                            i++;
                        } else {
                            i = 0;
                        }
                    }
                    img = ImageIO.read(new ByteArrayInputStream(buffer.toByteArray()));
                    prev_timestamp = System.currentTimeMillis();
                    out.notifyNewFrame();
                }
                ipChange = false;
            } catch (IOException e) {
                try {
                    Thread.sleep(PAUSE_TIME);
                } catch (InterruptedException ex) {
                    System.err.println("Video Stream Thread interrupted");
                    break;
                }
            }
        }
    }

    @Override
    public void setIP(int team) {
        this.team = team;
        ipChange = true;
    }
}
