/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dashboard2014;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;
import javax.imageio.ImageIO;
import javax.swing.Timer;

/**
 *
 * @author Robotics
 */
class TimerFrameGrabber implements FrameGrabber, ActionListener {

    private static final int LONG_PAUSE = 2000;
    private static final int FRAME_TIME = 16;
    private final Timer timer;
    private volatile BufferedImage img;
    private volatile int team;
    private final FrameNotifier out;

    public TimerFrameGrabber(FrameNotifier o) {
        img = null;
        timer = new Timer(LONG_PAUSE, this);
        timer.setCoalesce(true);
        timer.start();
        team = 0;
        out = o;
    }

    @Override
    public void setIP(int team) {
        this.team = team;
    }

    @Override
    public BufferedImage getLatestImage() {
        return img;
    }

    public static BufferedImage readImg(int team) {
        String addr = Backend.getCameraIP(team);
        String path = String.format("http://%s/axis-cgi/jpg/image.cgi?resolution=320x240", addr);
        try {
            return ImageIO.read(new URL(path));
        } catch (IOException e) {
            e.printStackTrace(System.err);
            return null;
        }
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        img = readImg(team);
        if (img == null) {
            timer.setDelay(LONG_PAUSE);
            System.err.println("Failed to reach camera.");
            return;
        }
        timer.setDelay(FRAME_TIME);
        out.notifyNewFrame();
    }
}
